#include "StdAfx.h"
#include <iostream>
#include "Box.h"
#include "vertex.h"
#include "polygon.h"
#include "texture.h"
#include "texturemanager.h"
#ifdef VC71
#include <GL/glut.h>
#else
#include "glut.h"
#endif


//create the polygons that make up the box
Box::Box(Vertex &p0, Vertex &p6, char *tex)
{
	//vertices
	Vertex p1 = Vertex(p0(0), p0(1), p6(2));
	Vertex p2 = Vertex(p6(0), p0(1), p6(2));
	Vertex p3 = Vertex(p6(0), p0(1), p0(2));
	Vertex p4 = Vertex(p0(0), p6(1), p0(2));
	Vertex p5 = Vertex(p0(0), p6(1), p6(2));
	Vertex p7 = Vertex(p6(0), p6(1), p0(2));

	//polygons
	addPolygon(p0, p3, p2, p1); //bottom
	addPolygon(p1, p5, p4, p0); //lhs
	addPolygon(p2, p6, p5, p1); //back
	addPolygon(p2, p3, p7, p6); //rhs
	addPolygon(p0, p4, p7, p3); //front
	addPolygon(p4, p5, p6, p7); //top

	texture = TextureManager::getInstance()->getTexture(tex);
}

Box::~Box(void)
{
	TextureManager::getInstance()->releaseTexture(texture);
}

//all we do is set up the texture and render all the polygons
void Box::render(void)
{
	//cout << texture->getFileName() << '\n';
	texture->render();
	PolygonGroup::render();
}
