#pragma once

/*
abstract class, presents an interface for an object that takes user input
and controls the simulation
*/

class Controller
{
public:
	Controller(void);
	virtual ~Controller(void);

	//methods to handle user input
	virtual void onKeyPress(unsigned char c, int x, int y) = 0;
	virtual void onMouseMove(int x, int y) = 0;
	virtual void onMouseButton(int button, int state, int x, int y) = 0;

	//set the position in the scene
	virtual void setX(float x)=0;
	virtual void setY(float y)=0;
	virtual void setZ(float z)=0;

};
