#include "StdAfx.h"
#include "light.h"
#ifdef VC71
#include <GL/glut.h>
#else
#include "glut.h"
#endif
#include "Vertex.h"

Light::Light(int id, float pos[])
{
	//store the light's details and cache the position in two different ways
	enabled = false;
	lightId = id;
	for (int i = 0; i < 4; ++i)
		light_position[i] = pos[i];
	position = new Vertex(pos[0], pos[1], pos[2]);
}

Light::~Light(void)
{
	delete position;
}


void Light::init()
{
	//opengl for a white light
	GLfloat light_colour[] = {1, 1, 1, 1};

	glLightfv(lightId, GL_DIFFUSE, light_colour);
	glLightfv(lightId, GL_SPECULAR, light_colour);
}

void Light::render(void)
{
	//send the position of the light to opengl
	glLightfv(lightId, GL_POSITION, light_position);
}

void Light::enable(bool e)
{
	//enable the light in opengl and keep track of its state
	enabled = e;
	if (e)
		glEnable(lightId);
	else
		glDisable(lightId);
}
