#include "StdAfx.h"
#include <iostream>
#include "PolygonGroup.h"
#include "polygon.h"
#include "vertex.h"
#include <float.h>

PolygonGroup::PolygonGroup(void)
{
}

//delete all the componenets of the polyhedran
PolygonGroup::~PolygonGroup(void)
{
	for (unsigned int i = 0; i < polygonList.size(); ++i)
		delete polygonList[i];
}

//add a polygon to the polyhedran
void PolygonGroup::addPolygon(Polygon *p)
{
	polygonList.push_back(p);
}

//renders the polyhedran in OpenGL, just goes through all the polygons calling their
//render method
void PolygonGroup::render(void)
{
	//int i=3;
	for (unsigned int i = 0; i < polygonList.size(); ++i)
		polygonList[i]->render();
}

void PolygonGroup::rotateY(float rads)
{
	//rotate all the polygons in the group
	for (unsigned int i = 0; i < polygonList.size(); ++i)
	{
		polygonList[i]->rotateY(rads);
	}
}

void PolygonGroup::addPolygon(Vertex &v1, Vertex &v2, Vertex &v3, Vertex &v4)
{
	//create a new polygon and add it to the group
	Polygon *p = new Polygon();
	p->addVertex(v1, Vertex(0, 0, 0));
	p->addVertex(v2, Vertex(0, 1, 0));
	p->addVertex(v3, Vertex(1, 1, 0));
	p->addVertex(v4, Vertex(1, 0, 0));
	addPolygon(p);
}

void PolygonGroup::renderShadowVolumes(Vertex *lightPosition)
{
	//render the shadow volumes of all the component polygons
	//it would be better to calculate the silhoette with respect to
	//the light and draw that shadow volume
	for (unsigned int i = 0; i < polygonList.size(); ++i)
	{
		//only render the shadow volumes if the polygon faces the light
		Vertex normal = *(polygonList[i]->getNormal());
		Vertex lightVector = polygonList[i]->getCenter() - *(lightPosition);
		double dot = dotProduct(normal, lightVector);

		if (dot < 0)
			polygonList[i]->renderShadowVolumes(lightPosition);
	}
}
