#pragma once

#include <vector>
#include "renderable.h"

class Polygon;
class Vertex;

using namespace std;

//a collection of polygons (not necessarily a polyhedran)
class PolygonGroup : public Renderable
{
public:
	PolygonGroup(void);
	virtual ~PolygonGroup(void);

	//spit out polygons for OpenGL
	void render(void);
	virtual void rotateY(float rads);

	//create and add a quad to the group
	virtual void addPolygon(Vertex &v1, Vertex &v2, Vertex &v3, Vertex &v4);
	void renderShadowVolumes(Vertex *lightPosition);

protected:
	//add a pre made polygon
	void addPolygon(Polygon *p);

	//polygon list
	vector<Polygon *> polygonList;
};
