#include "StdAfx.h"
#include "shadowvolume.h"
#include "polygon.h"
#include "Vertex.h"
#ifdef VC71
#include <GL/glut.h>
#else
#include "glut.h"
#endif
#include <iostream>

#define VOLUME_MULT 20

using namespace std;

//ShadowVolume::ShadowVolume(Polygon *caster, Vertex *lightPosition)
//{
//	calculateVolume(caster, lightPosition);
//}
//
//ShadowVolume::~ShadowVolume(void)
//{
//	for (unsigned int i = 0; i < faceList.size(); ++i)
//		delete[] faceList[i];
//	for (unsigned int i = 1; i < farCap.size(); ++i)
//		delete farCap[i];
//
//	delete farCap[0];
//}

//void ShadowVolume::calculateVolume(Polygon *caster, Vertex *lightPosition)
//{
//	unsigned int size = caster->order();
//	for (unsigned int i = 0; i < size; ++i)
//	{
//		Vertex *result = new Vertex[5];
//
//		Vertex v1 = *caster->getVertex(i);
//		Vertex v2 = *caster->getVertex((i+1)%size);
//
//		Vertex dir1 = v1 - *lightPosition;
//		dir1.scale(VOLUME_MULT, VOLUME_MULT, VOLUME_MULT);
//		Vertex v3 = dir1 + v1;
//
//		Vertex dir2 = v2 - *lightPosition;
//		dir2.scale(VOLUME_MULT, VOLUME_MULT, VOLUME_MULT);
//		Vertex v4 = dir2 + v2;
//		
//		//normal
//		result[4] = Polygon::calcNormal(v2, v1, v3, v4);
//
//		result[0] = v2;
//		result[1] = v1;
//		result[2] = v3;
//		result[3] = v4;
//
//		faceList.push_back(result);
//	}
//
//	//caps
//	//near cap
//	Vertex *normal = new Vertex(*(caster->getNormal()));
//	normal->scale(-1, -1, -1);
//	nearCap.push_back(normal);
//	for (unsigned int i = 0; i < size; ++i)
//	{
//		nearCap.push_back(caster->getVertex(i));
//	}
//
//	//far cap
//	farCap.push_back(normal);
//	for (int i = size-1; i >= 0; --i)
//	{
//		Vertex *v1 = caster->getVertex(i);
//		Vertex dir1 = *v1 - *lightPosition;
//		dir1.scale(VOLUME_MULT, VOLUME_MULT, VOLUME_MULT);
//		Vertex *v2 = new Vertex(dir1 + *v1);
//
//		farCap.push_back(v2);
//	}
//}
//
//void ShadowVolume::render(void)
//{
//	glBegin(GL_QUADS);
//	for (unsigned int i = 0; i < faceList.size(); ++i)
//	{
//		glNormal3f((faceList[i])[4](0), (faceList[i])[4](1), (faceList[i])[4](2));
//		for (int j = 0; j < 4; ++j)
//		{
//			glVertex3f((faceList[i])[j](0), (faceList[i])[j](1), (faceList[i])[j](2));
//		}
//	}
//	glEnd();
//
//	//caps
//	glPolygonOffset(1.0, 1.0);
//	glEnable(GL_POLYGON_OFFSET_FILL);
//
//	//near cap
//	renderCap(&nearCap);
//
//	glDisable(GL_POLYGON_OFFSET_FILL);
//
//	//far cap
//	renderCap(&farCap);
//}
//
//void ShadowVolume::renderCap(vector<Vertex *> *cap)
//{
//	glNormal3f((*(*cap)[0])(0), (*(*cap)[0])(1), (*(*cap)[0])(2));
//	glBegin(GL_POLYGON);
//	for (unsigned int i = 1; i < cap->size(); ++i)
//	{
//		glVertex3f((*(*cap)[i])(0), (*(*cap)[i])(1), (*(*cap)[i])(2));
//	}
//	glEnd();
//}


void ShadowVolume::renderShadowVolumesDirect(Polygon *caster, Vertex *lightPosition)
{
	//the number of vertices in the casting polygon
	unsigned int size = caster->order();

	glBegin(GL_QUADS);
	//for each vertex extrapolate it and a neighbouring vertex to make a quad and send to opengl
	for (unsigned int i = 0; i < size; ++i)
	{
		Vertex v1 = *caster->getVertex(i);
		Vertex v2 = *caster->getVertex((i+1)%size);

		Vertex dir1 = v1 - *lightPosition;
		dir1.scale(VOLUME_MULT, VOLUME_MULT, VOLUME_MULT);
		Vertex v3 = dir1 + v1;

		Vertex dir2 = v2 - *lightPosition;
		dir2.scale(VOLUME_MULT, VOLUME_MULT, VOLUME_MULT);
		Vertex v4 = dir2 + v2;
		
		//normal
		Vertex normal = Polygon::calcNormal(v2, v1, v3, v4);
		normal.scale(-1, -1, -1);
		glNormal3f(normal(0), normal(1), normal(2));

		glVertex3f(v2(0), v2(1), v2(2));
		glVertex3f(v1(0), v1(1), v1(2));
		glVertex3f(v3(0), v3(1), v3(2));
		glVertex3f(v4(0), v4(1), v4(2));
	}
	glEnd();

	//caps
	//near cap

	//polygon offset used to prevent z fighting
	glPolygonOffset(1.0, 1.0);
	glEnable(GL_POLYGON_OFFSET_FILL);

	Vertex normal = *caster->getNormal();
	glNormal3f(normal(0), normal(1), normal(2));
	glBegin(GL_POLYGON);
	for (unsigned int i = 0; i < size; ++i)
	{
		Vertex *curV = caster->getVertex(i);
		glVertex3f((*curV)(0), (*curV)(1), (*curV)(2));
	}
	glEnd();
	glDisable(GL_POLYGON_OFFSET_FILL);

	//far cap
	glBegin(GL_POLYGON);
	glNormal3f(normal(0), normal(1), normal(2));
	for (int i = size-1; i >= 0; --i)
	{
		Vertex *v1 = caster->getVertex(i);
		Vertex dir1 = *v1 - *lightPosition;
		dir1.scale(VOLUME_MULT, VOLUME_MULT, VOLUME_MULT);
		Vertex v2 = dir1 + *v1;

		glVertex3f(v2(0), v2(1), v2(2));
	}
	glEnd();
}

