#include "StdAfx.h"
#include "texturemanager.h"
#include "texture.h"

TextureManager::TextureManager(void)
{
}

TextureManager::TextureManager(const TextureManager&)
{
	//shouldn't be used, its a singleton
	assert(false);
}

TextureManager& TextureManager::operator= (const TextureManager&)
{
	//shouldn't be used, its a singleton
	assert(false);
	return *this;
}

TextureManager::~TextureManager(void)
{
}

Texture *TextureManager::getTexture(char *fileName)
{
	//try and pull the texture from the map
	Texture *result = textures[fileName];
	if (result == NULL)
	{
		//create a new texture if it can't be found
		result = new Texture(fileName);
		textures[fileName] = result;
	}

	result->incRefCount();
	return result;
}

void TextureManager::releaseTexture(Texture *tex)
{
	tex->decRefCount();
	if (tex->getRefCount() == 0)
	{
		//delete the texture if no one is using it
		textures[tex->getFileName()] = NULL;
		delete tex;
	}
}

void TextureManager::loadTexturesToGL(void)
{
	map<char *, Texture *>::iterator start = textures.begin();
	map<char *, Texture *>::iterator stop = textures.end();

	for (; start != stop; ++start)
	{
		start->second->loadToGL();
	}
}
