#include "StdAfx.h"
#include <iostream>
#include "thing.h"
#include "vertex.h"
#ifdef VC71
#include <GL/glut.h>
#else
#include "glut.h"
#endif


Thing::Thing(void)
{
}

Thing::~Thing(void)
{
}

void Thing::render(void)
{
	//render the Renderable in the correct position
	glPushMatrix();
	glTranslatef(positionX, positionY, positionZ);
	rend->render();
	glPopMatrix();
}

void Thing::renderShadowVolumes(Vertex *lightPosition)
{
	//render the Renderable's shadow volume in the correct place
	glPushMatrix();
	glTranslatef(positionX, positionY, positionZ);

	//adjust the light so it is in the right place
	Vertex translatedLightPos = Vertex(*lightPosition);
	translatedLightPos.translate(-positionX, -positionY, -positionZ);
	rend->renderShadowVolumes(&translatedLightPos);

	glPopMatrix();
}

void Thing::renderProjectedShadows(Vertex *lightPosition)
{
	//cout << positionX << ", " << positionY << ", " << positionZ << "\n";
	//render the Renderable's shadow in the correct place
	glPushMatrix();
	glTranslatef(positionX, positionY, positionZ);

	//adjust the light so it is in the right place
	Vertex translatedLightPos = Vertex(*lightPosition);
	translatedLightPos.translate(-positionX, -positionY, -positionZ);

	rend->renderProjectedShadows(&translatedLightPos, -positionY);

	glPopMatrix();
}